this.armorsmith_armor <- this.inherit("scripts/items/armor/armor", {
	m = {
		HiddenString = "",
		},
	function create()
	{
		this.armor.create();
		this.m.ID = "armor.body.armorsmith_armor";
		this.m.Description = "You reforged this armor personally.";
		this.m.Name = "Reforged Armor";
		this.m.ItemType = this.m.ItemType | this.Const.Items.ItemType.Named;
		this.m.IsDroppedAsLoot = true;
		this.m.ShowOnCharacter = true;
		this.m.Variant = 1;
		//this.updateVariant();
		this.m.ImpactSound = this.Const.Sound.ArmorHalfplateImpact;
		this.m.InventorySound = this.Const.Sound.ArmorLeatherImpact;
		this.m.Value = 0;
		this.m.Condition = 50;
		this.m.ConditionMax = 50;
		this.m.StaminaModifier = -2;
	}

	function updateVariant()
	{
		this.m.Value = this.m.Variant;
		local namestring = this.m.HiddenString;
		local stringarray = split(namestring, "%");
		if (stringarray.len() == 5)
		{
			this.m.Sprite = stringarray[0];
			this.m.SpriteDamaged = stringarray[1];
			this.m.SpriteCorpse = stringarray[2];
			this.m.IconLarge = stringarray[3];
			this.m.Icon = stringarray[4];
		}
	}
	
	function onSerialize( _out )
	{
		_out.writeString(this.m.HiddenString);
		_out.writeF32(this.m.ConditionMax);
		_out.writeI8(this.m.StaminaModifier);
		this.armor.onSerialize(_out);
	}

	function onDeserialize( _in )
	{
		this.m.HiddenString = _in.readString();
		this.m.ConditionMax = _in.readF32();
		this.m.StaminaModifier = _in.readI8();
		this.armor.onDeserialize(_in);
		//this.updateVariant();
	}
	
});

