this.armorsmith_helmet <- this.inherit("scripts/items/helmets/helmet", {
	m = {
		HiddenString = "",
		},
	function create()
	{
		this.helmet.create();
		this.m.ID = "armor.head.armorsmith_helmet";
		this.m.Description = "You reforged this helmet personally.";
		this.m.Name = "Reforged Helmet";
		this.m.ItemType = this.m.ItemType | this.Const.Items.ItemType.Named;
		this.m.IsDroppedAsLoot = true;
		this.m.ShowOnCharacter = true;
		this.m.HideHair = true;
		this.m.HideBeard = false;
		this.m.Variant = 1;
		//this.updateVariant();
		this.m.ImpactSound = this.Const.Sound.ArmorHalfplateImpact;
		this.m.InventorySound = this.Const.Sound.ArmorLeatherImpact;
		this.m.Value = 0;
		this.m.Condition = 50;
		this.m.ConditionMax = 50;
		this.m.StaminaModifier = -2;
	}

	function updateVariant()
	{
		this.m.Value = this.m.Variant;
		local namestring = this.m.HiddenString;
		local stringarray = split(namestring, "%");
		if (stringarray.len() == 7)
		{
			this.m.Sprite = stringarray[0];
			this.m.SpriteDamaged = stringarray[1];
			this.m.SpriteCorpse = stringarray[2];
			//this.m.IconLarge = stringarray[4];
			this.m.IconLarge = "";
			this.m.Icon = stringarray[3];
			this.m.Vision = stringarray[4].tointeger();
			this.m.HideHair = stringarray[5] == "true" ? true : false;
			this.m.HideBeard = stringarray[6] == "true" ? true : false;
		}
	}
	
	function onSerialize( _out )
	{
		_out.writeString(this.m.HiddenString);
		_out.writeF32(this.m.ConditionMax);
		_out.writeI8(this.m.StaminaModifier);
		this.helmet.onSerialize(_out);
	}

	function onDeserialize( _in )
	{
		this.m.HiddenString = _in.readString();
		this.m.ConditionMax = _in.readF32();
		this.m.StaminaModifier = _in.readI8();
		this.helmet.onDeserialize(_in);
		//this.updateVariant();
	}
});

